import { jsxs as rt, jsx as m } from "react/jsx-runtime";
import { o as st } from "../../chunks/useMergeRefs.DYDIMIZh.js";
import { y as at, i as ot, j as ct } from "../../chunks/index.Cmp87K7Q.js";
import lt, { useState as R, useEffect as it, useRef as k, useLayoutEffect as v } from "react";
import { TEXT_AREA_WRAPPER_CLASSNAME as nt, r as ut, TEXT_AREA_CLASSNAME as D, TEXT_AREA_CONTROL_RIGHT_CLASSNAME as dt, TEXT_AREA_HELPER_TEXT_CLASSNAME as P } from "../../chunks/constants.D-rfPeOH.js";
import c from "clsx";
function ft({
  value: t,
  defaultValue: a,
  finalValue: e,
  onChange: r = () => {
  },
  initialControlledDelay: s = 0
}) {
  const [d, i] = R(!1), [f, l] = R(
    a !== void 0 ? a : e
  ), p = (x) => {
    l(x), r == null || r(x);
  };
  return it(() => {
    (async () => t !== void 0 && !d && s > 0 && (await new Promise(
      (x) => setTimeout(x, s)
    ), i(!0)))();
  }, [t, s, d]), t !== void 0 ? !d && s > 0 ? ["", r, !0] : [t, r, !0] : [f, p, !1];
}
const pt = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", xt = ({
  mode: t
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), yt = ({
  focusMode: t
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), ht = ({
  noBorder: t,
  error: a
}) => c("border-2", {
  "border-border-dark": !t && !a,
  "focus:border-border-dark": !t && a,
  "border-border-error-dark": !t && a,
  "border-transparent": t
}), gt = ({
  disabled: t,
  raw: a,
  error: e,
  mode: r
}) => {
  if (a)
    return "";
  if (t)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-medium": r === "system",
      "text-copy-medium dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light": r === "system",
      "text-copy-medium dark:text-copy-error-dark": r === "alt-system"
    });
}, mt = ({
  error: t,
  raw: a,
  mode: e,
  disabled: r
}) => {
  if (a)
    return "";
  if (r)
    return c(
      P,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return c(P, "absolute px-2 font-medium", {
      "text-copy-medium": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-medium": e === "system",
      "text-copy-medium dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return c(P, "absolute px-2 font-medium", {
      "text-copy-error-light": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light": e === "system",
      "dark:text-copy-error-dark text-copy-error-light": e === "alt-system"
    });
}, kt = ({
  className: t,
  textAreaClassName: a,
  raw: e,
  focusMode: r,
  disabled: s,
  noBorder: d,
  error: i,
  spacing: f,
  mode: l
}) => {
  const p = e ? t : c(
    "relative flex w-full flex-col justify-center",
    nt,
    t,
    ut(f)
  ), x = e ? c(a) : c(
    D,
    a,
    pt(),
    xt({ mode: l }),
    yt({ focusMode: r }),
    ht({
      noBorder: d,
      error: i
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": s
    }
  ), T = e ? void 0 : "sr-only", C = gt({
    disabled: s,
    raw: e,
    error: i,
    mode: l
  }), _ = mt({
    error: i,
    raw: e,
    mode: l,
    disabled: s
  }), n = e ? void 0 : c(dt, "absolute");
  return {
    wrapper: p,
    textArea: x,
    accessibleLabel: T,
    visibleLabel: C,
    helperText: _,
    rightElement: n
  };
}, At = ({
  scrollHeight: t,
  currentHeight: a,
  currentLabelOffset: e = 0,
  currentHelperTextOffset: r = 0
}) => {
  let i, f;
  if (t > 0 && t !== a) {
    const l = t - a, p = Math.abs(l / 24);
    i = e + -1 * Math.sign(l) * (12 * p), f = r + Math.sign(l) * (12 * p);
  }
  return {
    labelOffset: i,
    helperTextOffset: f,
    scrollHeight: t
  };
}, Tt = lt.forwardRef(
  ({
    id: t,
    name: a,
    label: e,
    error: r = !1,
    raw: s = !1,
    className: d,
    textAreaClassName: i,
    mode: f = "system",
    focusMode: l = "system",
    value: p,
    defaultValue: x,
    disabled: T = !1,
    noBorder: C = !1,
    labelId: _,
    helperText: n = "",
    helperTextOnFocus: L = !1,
    rightElement: N,
    onChange: F,
    onFocus: $,
    onBlur: j,
    spacing: G,
    ...W
  }, V) => {
    const u = k(null), z = st([V, u]), [B, b] = at(), O = k(80), M = k(-25), h = k(null), X = k(30), E = k(null), A = ot({ id: t, prefix: `${D}-` }), [U, q] = R(0), [J, w] = R(
      !!(!L && n)
    ), K = `${a} error, ${n}`, g = kt({
      className: d,
      textAreaClassName: i,
      error: r,
      raw: s,
      focusMode: l,
      disabled: T,
      noBorder: C,
      spacing: G,
      mode: f
    }), [y, Q] = ft({
      value: p,
      initialControlledDelay: 20,
      defaultValue: x,
      onChange: (o) => {
        F && F({
          target: {
            value: o
          }
        });
      }
    }), Y = (o) => {
      Q(o.target.value);
    }, Z = (o) => {
      L && n && w(!0), $ && $(o);
    }, tt = (o) => {
      L && n && !y && w(!1), j && j(o);
    };
    return v(() => {
      b && b.width && q(b.width + 18 + 10);
    }, [b]), v(() => {
      s || u && u.current && y !== void 0 && (u.current.style.height = "inherit", u.current.style.height = u.current.scrollHeight + "px");
    }, [y, s]), v(() => {
      s || setTimeout(() => {
        var o;
        (o = h == null ? void 0 : h.current) == null || o.style.setProperty(
          "--av-text-area-wrapper-transition",
          y ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [y, s]), v(() => {
      var o, S;
      if (!s && u && u.current && y !== void 0) {
        const { labelOffset: H, helperTextOffset: I, scrollHeight: et } = At({
          scrollHeight: u.current.scrollHeight,
          currentHeight: O.current,
          currentLabelOffset: M.current,
          currentHelperTextOffset: X.current
        });
        H && (M.current = H, (o = h == null ? void 0 : h.current) == null || o.style.setProperty(
          "--av-text-area-label",
          `${H}px`
        )), I && (X.current = I, (S = E == null ? void 0 : E.current) == null || S.style.setProperty(
          "--av-text-area-helper-text",
          `${I}px`
        )), O.current = et || O.current;
      }
    }, [y, s]), /* @__PURE__ */ rt("div", { className: g.wrapper, children: [
      /* @__PURE__ */ m(
        "label",
        {
          htmlFor: A,
          id: _,
          className: g.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ m(
        "textarea",
        {
          ref: z,
          id: A,
          name: a,
          disabled: T,
          placeholder: s ? void 0 : " ",
          className: g.textArea,
          rows: 1,
          ...n && { "aria-describedby": `${A}-helper` },
          ...r && { "aria-invalid": "true" },
          ...N && !s && { style: { paddingRight: U } },
          value: y,
          onChange: Y,
          onFocus: Z,
          onBlur: tt,
          ...W
        }
      ),
      !s && /* @__PURE__ */ m(
        "label",
        {
          ref: h,
          "aria-hidden": !0,
          htmlFor: A,
          className: g.visibleLabel,
          children: e
        }
      ),
      J && /* @__PURE__ */ m(
        "div",
        {
          ref: E,
          id: `${A}-helper`,
          className: g.helperText,
          children: n
        }
      ),
      N && /* @__PURE__ */ m(
        "div",
        {
          ref: B,
          className: g.rightElement,
          children: N
        }
      ),
      r && n && /* @__PURE__ */ m(ct, { politeness: "polite", clearAnnouncementDelay: 500, children: K })
    ] });
  }
);
Tt.displayName = "TextArea";
export {
  Tt as TextArea
};
