import { jsxs as P, jsx as i } from "react/jsx-runtime";
import { y as R, i as S, j as $ } from "../../chunks/index.Cmp87K7Q.js";
import j, { useState as X, useLayoutEffect as F } from "react";
import { TEXT_INPUT_WRAPPER_CLASSNAME as U, r as H, TEXT_INPUT_CLASSNAME as E, TEXT_INPUT_HELPER_TEXT_CLASSNAME as T } from "../../chunks/constants.D-rfPeOH.js";
import a from "clsx";
const w = ({
  mode: t
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), D = ({
  focusMode: t
}) => a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), M = ({
  noBorder: t,
  error: s
}) => a("border-2", {
  "border-border-dark": !t && !s,
  "focus:border-border-dark": !t && s,
  "border-border-error-dark": !t && s,
  "border-transparent": t
}), W = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => {
  if (s)
    return "";
  if (t)
    return a("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "text-copy-lighter dark:text-copy-error-dark": r === "alt-system"
    });
}, q = ({
  error: t,
  raw: s,
  mode: e,
  disabled: r
}) => {
  if (s)
    return "";
  if (r)
    return a(
      T,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return a(T, "absolute px-2 font-medium", {
      "text-copy-lighter": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-lighter": e === "system",
      "text-copy-lighter dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return a(T, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": e === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": e === "alt-system"
    });
}, z = ({
  className: t,
  inputClassName: s,
  raw: e,
  disabled: r,
  noBorder: o,
  error: u,
  spacing: y,
  mode: n,
  focusMode: g
}) => {
  const p = e ? t : a(
    "relative flex w-full flex-col justify-center",
    U,
    t,
    H(y)
  ), x = e ? a(s) : a(
    E,
    s,
    "h-12 rounded-md px-4 text-base",
    w({ mode: n }),
    D({ focusMode: g }),
    M({ noBorder: o, error: u }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    }
  ), k = e ? void 0 : "sr-only", h = W({
    disabled: r,
    raw: e,
    error: u,
    mode: n
  }), b = q({
    error: u,
    raw: e,
    mode: n,
    disabled: r
  });
  return {
    wrapper: p,
    input: x,
    accessibleLabel: k,
    visibleLabel: h,
    helperText: b,
    rightElement: e ? void 0 : "absolute right-3"
  };
}, G = j.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: o = !1,
    className: u,
    inputClassName: y,
    mode: n = "system",
    focusMode: g = "system",
    disabled: p = !1,
    noBorder: x = !1,
    labelId: k,
    labelHidden: h = !1,
    type: b = "text",
    helperText: c = "",
    rightElement: m,
    spacing: I,
    ...N
  }, v) => {
    const [C, f] = R(), [L, _] = X(0), d = S({ id: t, prefix: `${E}-` }), A = `${s} error, ${c}`, l = z({
      className: u,
      inputClassName: y,
      error: r,
      raw: o,
      focusMode: g,
      disabled: p,
      noBorder: x,
      spacing: I,
      mode: n
    });
    return F(() => {
      f && f.width && _(f.width + 18 + 10);
    }, [f]), /* @__PURE__ */ P("div", { className: l.wrapper, children: [
      /* @__PURE__ */ i(
        "label",
        {
          htmlFor: d,
          id: k,
          className: l.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ i(
        "input",
        {
          ref: v,
          id: d,
          name: s,
          type: b,
          disabled: p,
          placeholder: o ? void 0 : " ",
          className: l.input,
          ...c && { "aria-describedby": `${d}-helper` },
          ...r && { "aria-invalid": "true" },
          ...m && !o && { style: { paddingRight: L } },
          ...N
        }
      ),
      !o && !h && /* @__PURE__ */ i(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: d,
          className: l.visibleLabel,
          children: e
        }
      ),
      c && /* @__PURE__ */ i(
        "div",
        {
          id: `${d}-helper`,
          className: l.helperText,
          children: c
        }
      ),
      m && /* @__PURE__ */ i(
        "div",
        {
          ref: C,
          className: l.rightElement,
          children: m
        }
      ),
      r && c && /* @__PURE__ */ i($, { politeness: "polite", clearAnnouncementDelay: 500, children: A })
    ] });
  }
);
G.displayName = "TextInput";
export {
  G as TextInput
};
