import { jsxs as p, jsx as c } from "react/jsx-runtime";
import { TOGGLE_CLASSNAME as b, r as k } from "../../chunks/constants.D-rfPeOH.js";
import t from "clsx";
const h = () => t("peer", "h-6", "w-11", "rounded-full"), m = ({
  focusMode: e
}) => t(
  "peer-focus:outline",
  "peer-focus:outline-2",
  "peer-focus:outline-offset-2",
  {
    "peer-focus:outline-focus-dark": e === "dark",
    "peer-focus:outline-focus-light": e === "light",
    "peer-focus:outline-focus-light dark:peer-focus:outline-focus-dark": e === "alt-system",
    "peer-focus:outline-focus-dark dark:peer-focus:outline-focus-light": e === "system"
  }
), y = () => t(
  "peer-checked:after:translate-x-full",
  // background color when checked
  "peer-checked:bg-violet-500",
  // knob circle and border color when checked
  "peer-checked:after:bg-white",
  "peer-checked:after:border-white"
), x = () => t(
  "after:left-[2px]",
  "after:top-[2px]",
  "after:border",
  "after:border-surface-light dark:after:border-surface-medium",
  "after:bg-surface-light dark:after:bg-surface-medium",
  "after:absolute",
  "after:h-5",
  "after:w-5",
  "after:rounded-full",
  "after:transition-all",
  "after:content-['']"
), C = ({
  mode: e,
  noBorder: r
}) => t({
  border: !r,
  "border-border-dark bg-surface-medium": e === "light",
  "border-border-light bg-surface-darker": e === "dark",
  "border-border-light bg-surface-darker dark:border-border-dark dark:bg-surface-medium": e === "alt-system",
  "border-border-dark bg-surface-medium dark:border-border-light dark:bg-surface-darker": e === "system"
}), T = ({
  mode: e,
  labelHidden: r
}) => r ? "sr-only" : t("ml-2 text-sm", {
  "text-copy-dark": e === "light",
  "text-copy-lighter": e === "dark",
  "text-copy-lighter dark:text-copy-dark": e === "alt-system",
  "text-copy-dark dark:text-copy-lighter": e === "system"
}), w = ({ spacing: e }) => t(
  b,
  "relative flex cursor-pointer items-center",
  k(e)
), N = ({
  mode: e,
  focusMode: r,
  labelHidden: a,
  spacing: l,
  noBorder: o
}) => ({
  toggle: t(
    h(),
    C({ mode: e, noBorder: o }),
    m({ focusMode: r }),
    x(),
    y()
  ),
  label: T({ mode: e, labelHidden: a }),
  input: "peer sr-only",
  wrapper: w({ spacing: l })
}), O = ({
  checked: e = !1,
  onChange: r,
  label: a,
  labelHidden: l = !1,
  name: o,
  mode: u = "system",
  focusMode: f = "system",
  spacing: g,
  noBorder: d = !1
}) => {
  const s = N({
    mode: u,
    focusMode: f,
    labelHidden: l,
    spacing: g,
    noBorder: d
  }), n = (i) => {
    r == null || r(i.target.checked);
  };
  return /* @__PURE__ */ p("label", { className: s.wrapper, children: [
    /* @__PURE__ */ c(
      "input",
      {
        name: o,
        checked: e,
        type: "checkbox",
        className: s.input,
        onChange: n
      }
    ),
    /* @__PURE__ */ c("div", { className: s.toggle }),
    /* @__PURE__ */ c("span", { className: s.label, children: a })
  ] });
};
export {
  O as Toggle
};
